#include <AccelStepper.h>
//******************************************
//********** PIN & State Definition ********
//******************************************
#define dirPin 10
#define stepPin 11
#define motorInterfaceType 1

const int endstopPin    = 12;
const int ledPin        = 9;
const int switch1Pin    = 8;
const int switch2Pin    = 7;
const int switch3Pin    = 6;
const int switch4Pin    = 5;
const int switch5Pin    = 4;
const int switch6Pin    = 3;
const int hornPin       = 2;

int       analogPin     = A3;

//******************************************
//******* PIN & State Definition END *******
//******************************************
const int minvalhit     = 50;
const int level6        = 1023;
const int level5        = 900;
const int level4        = 800;
const int level3        = 700;
const int level2        = 600;
const int level1        = 500;
int       active_level;
int gameState     = 0; //0=Schalter einlesen 1=ADC-Messung 2=Stepper-fahren 3=Signal 4=zurueck
int endstopState  = 0;
int switch1State  = 0;
int switch2State  = 0;
int switch3State  = 0;
int switch4State  = 0;
int switch5State  = 0;
int switch6State  = 0;
int val           = 0; // Variable, die den gelesenen Wert speichert
int val_old       = 0;
int val_for_map   = 0;
int stepper_travel;
long test1;
unsigned long myTime;
unsigned long myTime_old;
AccelStepper stepper = AccelStepper(motorInterfaceType, stepPin, dirPin);
//----------------------------------------------------------------------
void setup() { 
  pinMode(ledPin,    OUTPUT); 
  pinMode(hornPin,   OUTPUT);  
  pinMode(endstopPin, INPUT);  
  pinMode(switch1Pin, INPUT_PULLUP);
  pinMode(switch2Pin, INPUT_PULLUP);
  pinMode(switch3Pin, INPUT_PULLUP);
  pinMode(switch4Pin, INPUT_PULLUP);
  pinMode(switch5Pin, INPUT_PULLUP);
  pinMode(switch6Pin, INPUT_PULLUP);

  Serial.begin(9600);
            
  stepper.setMaxSpeed(1500);
  stepper.setAcceleration(800);
  //stepper.moveTo(1300);
}
//----------------------------------------------------------------------
void loop() {
//--------------------------- READ SWITCH ------------------------------  
    if(gameState==0) {
      switch1State = digitalRead(switch1Pin);
      switch2State = digitalRead(switch2Pin);
      switch3State = digitalRead(switch3Pin);      
      switch4State = digitalRead(switch4Pin);
      switch5State = digitalRead(switch5Pin);
      switch6State = digitalRead(switch6Pin);
   // Serial.println(switch1State);
     if (switch1State ==0)
      active_level = level1; 
     if (switch2State ==0)
      active_level = level2;
     if (switch3State ==0)
      active_level = level3;
     if (switch4State ==0)
      active_level = level4;
     if (switch5State ==0)
      active_level = level5;
     if (switch6State ==0)
      active_level = level6;
      gameState=1;
      endstopState =0;      
   }
//------------------------ READ SWITCH END------------------------------ 
//---------------------- ADC-MESSURE MAX-VALUE -------------------------                                    
    if(gameState==1) {
      digitalWrite(ledPin, HIGH);
      myTime = millis();
      val = analogRead(analogPin); // Pin einlesen
      if (val >= val_old and val > minvalhit){ 
        val_old = val;
        myTime_old = myTime;
        val_for_map = val_old;
      }
      if ((myTime - myTime_old > 1000)&& (val_old > 0)) {             //Measuretime 1 Sec
        gameState =2;
        val_old =0;
        myTime_old = 0;
        stepper.setCurrentPosition(0); 
      }
      //Serial.println("gamestate1" ); // Wert ausgeben                        
    }
//------------------- ADC-MESSURE MAX-VALUE END ------------------------ 
//---------------- VALUE MAPPING STEPPER MOVEMENT ---------------------- 
    if(gameState==2) {
      stepper_travel = map(val_for_map, 0, active_level, 0, 2600);
    if (stepper.distanceToGo() == 0)
      stepper.moveTo(stepper_travel);      
      stepper.run();
      if (stepper.currentPosition() == (stepper_travel)){              //Position reached
        gameState =3;
      }
    test1 =stepper.currentPosition();
//    Serial.print(test1); // Wert ausgeben
//    Serial.println(stepper_travel);
    digitalWrite(ledPin, LOW);
    }
//------------- VALUE MAPPING STEPPER MOVEMENT END ----------------------
//---------------- VARIABLE RESET HORN SIGNAL ---------------------------
    if(gameState==3) {
      val_for_map =0;
      //Serial.println("GAMESTATE3"); // Wert ausgeben
      if(stepper_travel >2200){
      digitalWrite(hornPin, HIGH);
      delay(300); 
      digitalWrite(hornPin, LOW); 
      delay(100);
      digitalWrite(hornPin, HIGH);
      delay(300); 
      digitalWrite(hornPin, LOW); 
      delay(100);
      digitalWrite(hornPin, HIGH);
      delay(600); 
      digitalWrite(hornPin, LOW); 
      delay(100);
      digitalWrite(hornPin, HIGH);
      delay(600); 
      digitalWrite(hornPin, LOW); 
      delay(100);                       
      }
      else{
      digitalWrite(hornPin, HIGH);
      delay(100); 
      digitalWrite(hornPin, LOW); 
      delay(200);
      digitalWrite(hornPin, HIGH);
      delay(100); 
      digitalWrite(hornPin, LOW); 
      delay(200);      
      }
      gameState =4;
      //stepper.setCurrentPosition(0);
    }
//-------------- VARIABLE RESET HORN SIGNAL END -------------------------
//---------------- STEPPER INIT RETURN TO START -------------------------
    if((gameState==4) &&(endstopState == 0)){
        endstopState = digitalRead(endstopPin);      
        stepper.moveTo(-stepper.currentPosition());      
        stepper.run();
        if (endstopState == 1) stepper.stop();
        if (stepper.currentPosition() == (0) ) {             //Position reached
          gameState =0;
        }
        test1 =stepper.currentPosition();
//        Serial.println("CurrentPosition");        
//        Serial.println(test1);     
    }
    if((gameState==4) &&(endstopState == 1))
          gameState =0;    
//-----------------------------------------------------------------------
//
//       
//------------------ Example Horn
//  digitalWrite(hornPin, HIGH);
//  delay(100); 
//  digitalWrite(hornPin, LOW); 
//  delay(200); 
//------------------ Example Horn END 
//------------------ Example Stepper
//    if (stepper.distanceToGo() == 0)
//      stepper.moveTo(-stepper.currentPosition());
//    stepper.run();
//------------------ Example Stepper  END
    }
